require "import"
import "android.content.*"

local selectedText = this.getText(node)
local links = {}

-- Extract all links from the selected text
for link in selectedText:gmatch("https?://%S+") do
    table.insert(links, link)
end

if #links > 0 then
    -- Count the number of links
    local linkCount = #links
    local formattedLinkCount = string.format("%d", linkCount):reverse():gsub("(%d%d%d)", "%1,"):reverse():gsub("^,", "")
    local linkCounterText = "Número de links: " .. formattedLinkCount .. "."

    -- Speak the total link count
    this.speak(linkCounterText)

    -- Add a delay of 2 seconds before sharing the links
    local startTime = os.time()
    local elapsedTime = 0
    while elapsedTime < 2 do
        elapsedTime = os.time() - startTime
    end

    -- Share the links only after speaking the total link count and the delay
    local intent = Intent(Intent.ACTION_SEND)
    intent.type = "text/plain"
    intent.putExtra(Intent.EXTRA_TEXT, table.concat(links, "\n"))

    -- Clear existing flags to allow multiple apps to appear in the chooser
    intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
    intent.addFlags(Intent.FLAG_GRANT_WRITE_URI_PERMISSION)

    this.startActivity(Intent.createChooser(intent, "Compartilhar link usando"))
else
    this.showToast("Nenhum link para compartilhar.")
end